<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_UBBCODE_INCLUDED') ) {
	define ('_OPN_CLASS_UBBCODE_INCLUDED', 1);

	/**
	* Convert HTML entities to all applicable characters
	*
	* @access public
	* @param string $string
	* @return string
	**/

	function un_htmlentities1 ($string) {

		$ts = array_flip (get_html_translation_table (HTML_ENTITIES) );
		return strtr ($string, $ts);

	}

	/*
	* @access   public
	*/

	class UBBCode {

		/*<{php4}>
		var $_tags = array();
		var $_elem = '';
		<{php4/}>*/

		/*<{php5}>
		private $_tags = array();
		private $_elem = '';
		<{php5/}>*/

		/*<{delete}>*/
		var $_tags = array();
		var $_elem = array();
		/*<{delete/}>*/

		function _setQuote ($author = '', $date = '', $text) {

			global $opnConfig;

			$return = '';
			if ($date != '') {
				$opnConfig['opndate']->setTimestamp ($date);
				$opnConfig['opndate']->formatTimestamp ($tempdate = '', _DATE_DATESTRING4);
				$opnConfig['opndate']->formatTimestamp ($temptime = '', _DATE_DATESTRING9);
				if ($author != '') {
					$return = sprintf (_BBCODE_QUOTETIMEAUTHOR, $author, $tempdate, $temptime);
				} else {
					$return = sprintf (_BBCODE_QUOTETIME, $tempdate, $temptime);
				}
			} elseif ($author != '') {
				$return = sprintf (_BBCODE_QUOTEAUTHOR, $author);
			}
			if ($return != '') {
				$return = '<span class="quoteheader">' . $return . '</span>';
			}
			$return = $return . '<blockquote>' . $text;
			return $return;

		}

		function _getQuote ($author, $date, $time, $text) {

			global $opnConfig;

			$stamp = $date . ' ' . $time;
			$opnConfig['opndate']->locale2iso ($stamp);
			$opnConfig['opndate']->formatTimestamp ($stamp);
			if ($author != '') {
				return '[quote author=' . $author . ' date=' . $stamp . ']' . $text;
			}
			return '[quote date=' . $stamp . ']' . $text;

		}

		/**
		* Encodes the string
		* Removes all html tags and exchanges only the ubb tags and with html tags.
		*
		*
		* @access   public
		* @param	String	  $str
		*/

		function ubbencode (&$str) {
			if ($str <> '') {
				$vstr = $str;
				$str = str_replace ('[bull]', '&bull;', $str);
				$str = str_replace ('[trade]', '&trade;', $str);
				$str = str_replace ('[euro]', '&euro;', $str);
				$str = str_replace ('[sect]', '&sect;', $str);
				$str = str_replace ('[copy]', '&copy;', $str);
				$str = str_replace ('[reg]', '&reg;', $str);
				$str = str_replace ('[deg]', '&deg;', $str);
				$str = str_replace ('[hellip]', '&hellip;', $str);
				$str = str_replace ('[lt]', '&lt;', $str);
				$str = str_replace ('[gt]', '&gt;', $str);
				$str = str_replace ('[permil]', '&permil;', $str);
				$str = preg_replace ("#\[b\](.*?)\[/b\]#si", "<strong>\\1</strong>", $str);
				$str = preg_replace ("#\[move\](.*?)\[/move\]#si", "<marquee>\\1</marquee>", $str);
				$str = preg_replace ("#\[table\](.*?)\[/table\]#si", "<table>\\1</table>", $str);
				$str = str_replace ('[table]', '<table>', $str);
				$str = str_replace ('[/table]', '</table>', $str);
				$str = preg_replace ("#\[tr\](.*?)\[/tr\]#si", "<tr>\\1</tr>", $str);
				$str = str_replace ('[tr]', '<tr>', $str);
				$str = str_replace ('[/tr]', '</tr>', $str);
				$str = preg_replace ("#\[td\](.*?)\[/td\]#si", "<td>\\1</td>", $str);
				$str = str_replace ('[td]', '<td>', $str);
				$str = str_replace ('[/td]', '</td>', $str);
				$str = preg_replace ("#\[s\](.*?)\[/s\]#si", "<del>\\1</del>", $str);
				$str = preg_replace ("#\[i\](.*?)\[/i\]#si", "<em>\\1</em>", $str);
				$str = preg_replace ("#\[sup\](.*?)\[/sup\]#si", "<sup>\\1</sup>", $str);
				$str = preg_replace ("#\[sub\](.*?)\[/sub\]#si", "<sub>\\1</sub>", $str);
				$str = preg_replace ("#\[tt\](.*?)\[/tt\]#si", "<tt>\\1</tt>", $str);
				$str = preg_replace ("#\[pre\](.*?)\[/pre\]#si", "<pre>\\1</pre>", $str);
				$str = preg_replace ("#\[u\](.*?)\[/u\]#si", "<ins>\\1</ins>", $str);
				$str = preg_replace ("#\[code\](.*?)\[/code\]#sie", "'<code>'.htmlspecialchars(un_htmlentities1('\\1')).'</code>'", $str);
				if ($vstr != $str) {
					$vstr = true;
				}
				$lang = 'en';
				if (defined ('_OPN_WIKI_LANG') ) {
					$lang = _OPN_WIKI_LANG;
				}
				$str = preg_replace ("#\[align=(.*?)\](.*?)\[/align\]#si", "<div align=\"\\1\">\\2</div>", $str);
				$str = preg_replace ("#\[left\](.*?)\[/left\]#si", "<div align=\"left\">\\1</div>", $str);
				$str = preg_replace ("#\[right\](.*?)\[/right\]#si", "<div align=\"right\">\\1</div>", $str);
				$str = preg_replace ("#\[center\](.*?)\[/center\]#si", "<div align=\"center\">\\1</div>", $str);
				$str = preg_replace ("#\[justify\](.*?)\[/justify\]#si", "<div align=\"justify\">\\1</div>", $str);
				$str = preg_replace ("#\[size=(.*?)\](.*?)\[/size\]#si", "<span style=\"font-size: \\1;\">\\2</span>", $str);
				$str = preg_replace ("#\[font=(.*?)\](.*?)\[/font\]#si", "<span style=\"font-family: \\1;\">\\2</span>", $str);
				$str = preg_replace ("#\[url\]http://(.*?)\[/url\]#si", "<a class=\"opncenterbox\" href=\"http://\\1\" target=\"_blank\">\\1</a>", $str);
				$str = preg_replace ("#\[url\](.*?)\[/url\]#si", "<a class=\"opncenterbox\" href=\"http://\\1\" target=\"_blank\">\\1</a>", $str);
				$str = preg_replace ("#\[url=(http://)?(.*?)\](.*?)\[/url\]#si", "<a class=\"opncenterbox\" href=\"http://\\2\" target=\"_blank\">\\3</a>", $str);
				$str = preg_replace ("#\[url=?(.*?)\](.*?)\[/url\]#si", "<a class=\"opncenterbox\" href=\"http://\\1\" target=\"_blank\">\\2</a>", $str);
				$str = preg_replace ("#\[color=(.*?)\](.*?)\[/color\]#si", "<span style=\"color: \\1;\">\\2</span>", $str);
				$str = preg_replace ("#\[email\](.*?)\[/email\]#si", "<a class=\"opncenterbox\" href=\"mailto:\\1\">\\1</a>", $str);
				$str = preg_replace ("#\[email=?(.*?)\](.*?)\[/email\]#si", "<a class=\"opncenterbox\" href=\"mailto:\\1\">\\2</a>", $str);
				$str = preg_replace ("#\[img\](.*?)\[/img\]#si", "<img src=\"\\1\" alt=\"\" title=\"\" border=\"0\" />", $str);
				$str = preg_replace ("#\[img=?(.*?)\](.*?)\[/img\]#si", "<img src=\"\\2\" alt=\"\\1\" title=\"\\1\" border=\"0\" />", $str);
				$str = preg_replace ("#\[wikipedia\](.*?)\[/wikipedia\]#si", "<a class=\"wiki\" href=\"http://" . $lang . ".wikipedia.org/wiki/\\1\" target=\"_blank\">\\1</a>", $str);
				$str = preg_replace ("#\[wikipedia=?(.*?)\](.*?)\[/wikipedia\]#si", "<a class=\"wiki\" href=\"http://\\1.wikipedia.org/wiki/\\2\" target=\"_blank\">\\2</a>", $str);
				$str = preg_replace ("#\[wikibook\](.*?)\[/wikibook\]#si", "<a class=\"wiki\" href=\"http://" . $lang . ".wikibooks.org/wiki/\\1\" target=\"_blank\">\\1</a>", $str);
				$str = preg_replace ("#\[wikibook=?(.*?)\](.*?)\[/wikibook\]#si", "<a class=\"wiki\" href=\"http://\\1.wikibooks.org/wiki/\\2\" target=\"_blank\">\\2</a>", $str);
				$str = preg_replace ("#\[quote author=?(.*?) date=?(.*?)\](.*?)#sie", "\$this->_setQuote('\\1', '\\2', '\\3');", $str);
				$str = preg_replace ("#\[quote author=?(.*?)\](.*?)#sie", "\$this->_setQuote('\\1', '', '\\2');", $str);
				$str = preg_replace ("#\[quote=?(.*?)\](.*?)#sie", "\$this->_setQuote('\\1', '', '\\2');", $str);
				$str = preg_replace ("#\[quote date=?(.*?)\](.*?)#sie", "\$this->_setQuote('', '\\1', '\\2');", $str);
				$str = preg_replace ("#\[quote](.*?)#sie", "\$this->_setQuote('', '', '\\1');", $str);
				$str = preg_replace ("/quote\\]/i", "quote]", $str);
				// make lower case
				$str = preg_replace ("/\[quote\]\r\n/i", '<blockquote>' . _BBCODE_QUOTE . '<br />', $str);
				$str = preg_replace ("/\[quote\]/i", '<blockquote>' . _BBCODE_QUOTE . '<br />', $str);
				$str = preg_replace ("/\[\/quote\]\r\n/i", "</blockquote>\r\n", $str);
				$str = str_replace ('[/quote]', '</blockquote>', $str);
				$str = preg_replace ("#\[list\](.*?)\[/list\]#si", "<ul>\\1</ul>", $str);
				$str = str_replace ('[list]', '<ul>', $str);
				$str = str_replace ('[/list]', '</ul>', $str);
				$str = preg_replace ("#\[dl\](.*?)\[/dl\]#si", "<dl>\\1</dl>", $str);
				$str = str_replace ('[dl]', '<dl>', $str);
				$str = str_replace ('[/dl]', '</dl>', $str);
				$str = preg_replace ("#\[dt\](.*?)\[/dt\]#si", "<dt>\\1</dt>", $str);
				$str = str_replace ('[dt]', '<dt>', $str);
				$str = str_replace ('[/dt]', '</dt>', $str);
				$str = preg_replace ("#\[dd\](.*?)\[/dd\]#si", "<dd>\\1</dd>", $str);
				$str = str_replace ('[dd]', '<dd>', $str);
				$str = str_replace ('[/dd]', '</dd>', $str);
				$str = preg_replace ("#\[olist=a\]#si", '<ol type="a">', $str);
				$str = preg_replace ("#\[olist=1\]#si", '<ol type="1">', $str);
				$str = preg_replace ("#\[olist\](.*?)\[/olist\]#si", "<ol>\\1</ol>", $str);
				$str = str_replace ('[/olist]', '</ol>', $str);
				$str = str_replace ('[*]', '<li>', $str);
				$str = str_replace ('[/*]', '</li>', $str);
				$str = str_replace ('[hr]', '<hr />', $str);
				// $str = str_replace(_OPN_HTML_NL, '<br />', $str);
				// opn_nl2br($str);
				if ($vstr === true) {
					$str = str_replace ('\\&quot;', '&quot;', $str);
				}
			}

		}

		/**
		* Replace the occurence of a BBCode Tag with placeholders.
		*
		* @param $str		The string where the BBCode should be replaced
		* @param $tag		The Tag to be replaced
		* @param $tagarray	The Resultarray with the Tags for restoring the tags
		*/

		function replace_ubb_tag (&$str, $tag, &$tagarray) {

			preg_match_all ("=\[" . $tag . "[^\]]*\](.*)\[/" . $tag . "\]=si", $str, $tagarray);
			for ($i = 0, $max = count ($tagarray[0]); $i< $max; $i++) {
				$str = preg_replace ('=' . preg_quote ($tagarray[0][$i]) . '=siU', ':' . $tag . $i . ':', $str);
			}

		}

		/**
		* Replace the placeholders with the BBCode Tag
		*
		* @param $str			The string where the Placeholders should be replaced
		* @param $replacment	The BBCode Tag for replacement
		* @param $tagarray		The Tagarray with the Tag content
		*/

		function restore_ubb_tag (&$str, $replacment, $tagarray) {

			for ($i = 0, $max = count ($tagarray[0]); $i< $max; $i++) {
				$str = preg_replace ('=' . preg_quote (':' . $replacment . $i . ':') . '=siU', $tagarray[0][$i], $str);
			}

		}

		/**
		* Replace the [wikipedia] tags
		*
		* @param $content
		*/

		function Replace_WikiCode (&$content) {

			$this->replace_ubb_tag ($content, 'wikipedia', $this->_tags['wikipedia'] = array () );
			$this->replace_ubb_tag ($content, 'wikibook', $this->_tags['wikibook'] = array () );

		}

		/**
		* Restore the [wikipedia] tags
		*
		* @param $content
		*/

		function Restore_WikiCode (&$content) {

			$this->restore_ubb_tag ($content, 'wikipedia', $this->_tags['wikipedia']);
			$this->restore_ubb_tag ($content, 'wikibook', $this->_tags['wikibook']);
			$this->_tags['wikipedia'] = array ();
			$this->_tags['wikivooks'] = array ();

		}

		/**
		* Replace the [url] tags
		*
		* @param $content
		*/

		function Replace_UrlCode (&$content) {

			$this->replace_ubb_tag ($content, 'url', $this->_tags['url'] = array () );

		}

		/**
		* Restore the [url] tags
		*
		* @param $content
		*/

		function Restore_UrlCode (&$content) {

			$this->restore_ubb_tag ($content, 'url', $this->_tags['url']);
			$this->_tags['url'] = array ();

		}

		/**
		* Replace the [email] tags
		*
		* @param $content
		*/

		function Replace_EmailCode (&$content) {

			$this->replace_ubb_tag ($content, 'email', $this->_tags['email'] = array () );

		}

		/**
		* Restore the [email] tags
		*
		* @param $content
		*/

		function Restore_EmailCode (&$content) {

			$this->restore_ubb_tag ($content, 'email', $this->_tags['email']);
			$this->_tags['email'] = array ();

		}

		/**
		* Replace the [quote] tags
		*
		* @param $content
		*/

		function Replace_QuoteCode (&$content) {

			$this->replace_ubb_tag ($content, 'quote', $this->_tags['quote'] = array () );

		}

		/**
		* Restore the [quote] tags
		*
		* @param $content
		*/

		function Restore_QuoteCode (&$content) {

			$this->restore_ubb_tag ($content, 'quote', $this->_tags['quote']);
			$this->_tags['quote'] = array ();

		}

		/**
		* Replace the [code] tags
		*
		* @param $content
		*/

		function Replace_CodeCode (&$content) {

			$this->replace_ubb_tag ($content, 'code', $this->_tags['code'] = array () );

		}

		/**
		* Restore the [code] tags
		*
		* @param $content
		*/

		function Restore_CodeCode (&$content) {

			$this->restore_ubb_tag ($content, 'code', $this->_tags['code']);
			$this->_tags['code'] = array ();

		}

		/**
		* Replace special BBCode Tags
		*
		* @param $content
		*/

		function Replace_SpecialCodes (&$content) {

			$this->Replace_WikiCode ($content);
			$this->Replace_EmailCode ($content);
			$this->Replace_UrlCode ($content);
			$this->Replace_CodeCode ($content);
			$this->Replace_QuoteCode ($content);

		}

		/**
		* Restore special BBCode Tags
		*
		* @param $content
		*/

		function Restore_SpecialCodes (&$content) {

			$this->Restore_QuoteCode ($content);
			$this->Restore_CodeCode ($content);
			$this->Restore_UrlCode ($content);
			$this->Restore_EmailCode ($content);
			$this->Restore_WikiCode ($content);

		}

		/**
		* Strips all UBB tags
		* Removes all ubb tags and leaves only plain text
		*
		*
		* @access   public
		* @param	String	  $str
		*/

		function ubbstrip (&$str) {
			if ($str <> '') {
				$str = preg_replace ("[\[(.*?)\]]", "", $str);
			}

		}

		/**
		* Decodes the string
		* Removes the html tags and replaces them with ubb code tags
		*
		* @access   public
		* @param	String	  $str
		*/

		function ubbdecode (&$str) {
			if ($str <> '') {
				$str = str_replace ('&bull;', '[bull]', $str);
				$str = str_replace ('&trade;', '[trade]', $str);
				$str = str_replace ('&euro;', '[euro]', $str);
				$str = str_replace ('&sect;', '[sect]', $str);
				$str = str_replace ('&copy;', '[copy]', $str);
				$str = str_replace ('&reg;', '[reg]', $str);
				$str = str_replace ('&deg', '[deg]', $str);
				$str = str_replace ('&hellip;', '[hellip]', $str);
				$str = str_replace ('&lt;', '[lt]', $str);
				$str = str_replace ('&gt;', '[gt]', $str);
				$str = str_replace ('&permil;', '[permil]', $str);
				$str = str_replace ('<marquee>', '[move]', $str);
				$str = str_replace ('</marquee>', '[/move]', $str);
				$str = str_replace ('<table>', '[table]', $str);
				$str = str_replace ('</table>', '[/table]', $str);
				$str = str_replace ('<tr>', '[tr]', $str);
				$str = str_replace ('</tr>', '[/tr]', $str);
				$str = str_replace ('<td>', '[td]', $str);
				$str = str_replace ('</td>', '[/td]', $str);
				$str = str_replace ('<strong>', '[b]', $str);
				$str = str_replace ('</strong>', '[/b]', $str);
				$str = str_replace ('<b>', '[b]', $str);
				$str = str_replace ('</b>', '[/b]', $str);
				$str = str_replace ('<sup>', '[sup]', $str);
				$str = str_replace ('</sup>', '[/sup]', $str);
				$str = str_replace ('<sub>', '[sub]', $str);
				$str = str_replace ('</sub>', '[/sub]', $str);
				$str = str_replace ('<tt>', '[tt]', $str);
				$str = str_replace ('</tt>', '[/tt]', $str);
				$str = str_replace ('<pre>', '[pre]', $str);
				$str = str_replace ('</pre>', '[/pre]', $str);
				$str = str_replace ('<del>', '[s]', $str);
				$str = str_replace ('</del>', '[/s]', $str);
				$str = str_replace ('<em>', '[i]', $str);
				$str = str_replace ('</em>', '[/i]', $str);
				$str = str_replace ('<i>', '[i]', $str);
				$str = str_replace ('</i>', '[/i]', $str);
				$str = str_replace ('<ins>', '[u]', $str);
				$str = str_replace ('</ins>', '[/u]', $str);
				$str = str_replace ('<dl>', '[dl]', $str);
				$str = str_replace ('</dl>', '[/dl]', $str);
				$str = str_replace ('<dt>', '[dt]', $str);
				$str = str_replace ('</dt>', '[/dt]', $str);
				$str = str_replace ('<dd>', '[dd]', $str);
				$str = str_replace ('</dd>', '[/dd]', $str);
				$str = str_replace ('<hr />', '[hr]', $str);
				$str = preg_replace ("#<div align=\"left\">(.*?)</div>#si", "[left]\\1[/left]", $str);
				$str = preg_replace ("#<div align=\"right\">(.*?)</div>#si", "[right]\\1[/right]", $str);
				$str = preg_replace ("#<div align=\"center\">(.*?)</div>#si", "[center]\\1[/center]", $str);
				$str = preg_replace ("#<div align=\"justify\">(.*?)</div>#si", "[justify]\\1[/justify]", $str);
				$str = preg_replace ("#<div align=\"(.*?)\">(.*?)</div>#si", "[align=\\1]\\2[/align]", $str);
				$str = preg_replace ("#<span style=\"font-size: (.*?);\">(.*?)</span>#si", "[size=\\1]\\2[/size]", $str);
				$str = preg_replace ("#<span style=\"font-family: (.*?);\">(.*?)</span>#si", "[font=\\1]\\2[/font]", $str);
				$str = str_replace ('<code>', '[code]', $str);
				$str = str_replace ('</code>', '[/code]', $str);
				$str = preg_replace ("#<span style=\"color: (.*?);\">(.*?)</span>#si", "[color=\\1]\\2[/color]", $str);
				$str = preg_replace ("#<a class=\"wiki\" href=\"http://(.*?).wikipedia.org/wiki/(.*?)\" target=\"_blank\">(.*?)</a>#si", "[wikipedia=\\1]\\3[/wikipedia]", $str);
				$str = preg_replace ("#<a class=\"wiki\" href=\"http://(.*?).wikibooks.org/wiki/(.*?)\" target=\"_blank\">(.*?)</a>#si", "[wikibook=\\1]\\3[/wikibook]", $str);
				$str = preg_replace ("#<a href=\"(.*?)\" target=\"_blank\">(.*?)</a>#si", "[url=\\1]\\2[/url]", $str);
				$str = preg_replace ("#<a class=\"opncenterbox\" href=\"(.*?)\" target=\"_blank\">(.*?)</a>#si", "[url=\\1]\\2[/url]", $str);
				$str = preg_replace ("#<a href=\"mailto:(.*?)\">(.*?)</a>#si", "[email=\\1]\\2[/email]", $str);
				$str = preg_replace ("#<a class=\"opncenterbox\" href=\"mailto:(.*?)\">(.*?)</a>#si", "[email=\\1]\\2[/email]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\" alt=\"\" />#si", "[img]\\1[/img]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\" alt=\"\" border=\"0\" />#si", "[img]\\1[/img]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\" alt=\"\" title=\"\" border=\"0\" />#si", "[img]\\1[/img]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\" alt=\"(.*?)\" title=\"(.*?)\" border=\"0\" />#si", "[img=\\2]\\1[/img]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\" alt=\"(.*?)\" border=\"0\" />#si", "[img=\\2]\\1[/img]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\" alt=\"(.*?)\" />#si", "[img=\\2]\\1[/img]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\" />#si", "[img]\\1[/img]", $str);
				$str = preg_replace ("#<img src=\"(.*?)\">#si", "[img]\\1[/img]", $str);
				$pattern = "#<span class=\"quoteheader\">" . sprintf (_BBCODE_QUOTEAUTHOR, '(.*?)') . '</span><blockquote>(.*?)#si';
				$str = preg_replace ($pattern, '[quote=\\1]\\2', $str);
				$pattern = "#<span class=\"quoteheader\">" . sprintf (_BBCODE_QUOTETIME, '(.*?)', '(.*?)') . '</span><blockquote>(.*?)#sie';
				$str = preg_replace ($pattern, "\$this->_getQuote('','\\1','\\2','\\3')", $str);
				$pattern = "#<span class=\"quoteheader\">" . sprintf (_BBCODE_QUOTETIMEAUTHOR, '(.*?)', '(.*?)', '(.*?)') . '</span><blockquote>(.*?)#sie';
				$str = preg_replace ($pattern, "\$this->_getQuote('\\1','\\2','\\3','\\4')", $str);
				$str = str_replace ('<blockquote>' . _BBCODE_QUOTE . '<br />', '[quote]', $str);
				$str = str_replace ('<blockquote>' . _BBCODE_QUOTE . '<br>', '[quote]', $str);
				$str = str_replace ('<blockquote>' . _BBCODE_QUOTE . _OPN_HTML_NL, '[quote]', $str);
				$str = str_replace ('<blockquote>', '[quote]', $str);
				$str = str_replace ('</blockquote>', '[/quote]', $str);
				$str = str_replace ('<ul>', '[list]', $str);
				$str = str_replace ('</ul>', '[/list]', $str);
				$str = str_replace ('<ol type="a">', '[olist=a]', $str);
				$str = str_replace ('<ol type="1">', '[olist=1]', $str);
				$str = str_replace ('<ol>', '[olist]', $str);
				$str = str_replace ('</ol>', '[/olist]', $str);
				$str = str_replace ('<li>', '[*]', $str);
				$str = str_replace ('</li>', '[/*]', $str);
				$str = str_replace ('<br />' . _OPN_HTML_NL, _OPN_HTML_NL, $str);
				$str = str_replace ('<br />', _OPN_HTML_NL, $str);
				$str = str_replace ('<br>', _OPN_HTML_NL, $str);
			}

		}

		/**
		* Dumps the code tags
		* Displays a <pre> block with the "ubb_def" css style class
		*
		* @access   public
		* @param	String	  $str
		*/

		function listCodes (&$str) {

			getLanguageDef (_OPN_ROOT_PATH . 'language/ubbcode/language/');
			$str = '<div style="margin-left:10px; margin-right:10px;"><div class="normaltextbold" align="center">' . _BBCODE_DEF_WHATISBBCODE . '</div><br />';
			$table =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_TableClass ('default');
			$table->AddDataRow (array (_BBCODE_DEF_BBCODEDESCRIPTION . '<br />' . _BBCODE_DEF_DISPLAY_BBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_CURRENTBBCODES . '</span>'), array ('center') );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_URLHYPERLINKING . '</span>') );
			$hlp = _BBCODE_DEF_URLHYPERLINKINGINBBCODE;
			$hlp .= '<ul><li>http://' . _BBCODE_DEF_YOURDOMAINEXAMPLE . '</li><li>' . _BBCODE_DEF_YOURDOMAINEXAMPLE . '</li></ul>';
			$table->AddDataRow (array ($hlp) );
			$table->AddDataRow (array (_BBCODE_DEF_URLHYPERLINKINGEXAMPLES) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_EMAILLINK . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_EMAILLINKINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_ADDINGIMAGE . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_ADDINGIMAGEINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_BOLDANDITALICS . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_BOLDANDITALICSINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_BULLETSLISTS . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_BULLETSLISTSINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_QUOTING . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_QUOTINGINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_CODETAG . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_CODETAGINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array (_BBCODE_DEF_OFNOTE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array (_BBCODE_DEF_INCORRECTBBCODE) );
			$table->GetTable ($str);
			$str .= '</div>';

		}

		function putbbcode ($tabindex, $elem, $smilieid = '', $userimagesid = '') {

			getLanguageDef (_OPN_ROOT_PATH . 'language/ubbcode/language/');
			$this->_elem = 'document.' . $elem;
			$form =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_FormularClass ('default');
			$form->AddTable ();
			$form->AddOpenRow ();
			$form->SetVAlign ('middle');
			$form->SetVAlignTab ('middle');
			$form->SetSameCol ();
			$this->build_bbcode1_image (_BBCODE_BOLD, _BBCODE_HTML_BOLD, 'b', 'bold.gif', $form);
			$this->build_bbcode1_image (_BBCODE_ITALIC, _BBCODE_HTML_ITALIC, 'i', 'italicize.gif', $form);
			$this->build_bbcode1_image (_BBCODE_UNDERLINE, _BBCODE_HTML_UNDERLINE, 'u', 'underline.gif', $form);
			$this->build_bbcode1_image (_BBCODE_STRIKE, _BBCODE_HTML_STRIKE, 's', 'strike.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_SUPERSCRIPT, _BBCODE_HTML_SUPERSCRIPT, 'sup', 'sup.gif', $form);
			$this->build_bbcode1_image (_BBCODE_SUBSCRIPT, _BBCODE_HTML_SUBSCRIPT, 'sub', 'sub.gif', $form);
			$this->build_bbcode1_image (_BBCODE_TT, _BBCODE_HTML_TT, 'tt', 'tele.gif', $form);
			$this->build_bbcode1_image (_BBCODE_MARQUEE, '', 'move', 'move.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_PRE, _BBCODE_HTML_PRE, 'pre', 'pre.gif', $form);
			$this->build_bbcode1_image (_BBCODE_LEFT, '', 'left', 'left.gif', $form);
			$this->build_bbcode1_image (_BBCODE_CENTER, '', 'center', 'center.gif', $form);
			$this->build_bbcode1_image (_BBCODE_RIGHT, '', 'right', 'right.gif', $form);
			$this->build_bbcode1_image (_BBCODE_JUSTIFY, '', 'justify', 'justify.png', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_HR, '', 'hr', 'hr.gif', $form);
			// $this->_add_bbcode_ruler ($form);
			$form->SetEndCol ();
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$this->build_bbcode_image (_BBCODE_IMAGE, 'image', 'img.gif', $form);
			$this->build_bbcode_image (_BBCODE_EMAIL, 'email', 'email.gif', $form);
			$this->build_bbcode_image (_BBCODE_URL, 'url', 'url.gif', $form);
			$this->build_bbcode_image (_BBCODE_WIKI, 'wikipedia', 'wiki.png', $form);
			$this->build_bbcode_image (_BBCODE_WIKIBOOK, 'wikibook', 'wiki.png', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_QUOTE1, '', 'quote', 'quote.gif', $form);
			$this->build_bbcode1_image (_BBCODE_CODE, '', 'code', 'code.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_LIST, '', 'list', 'ul.png', $form);
			$this->build_bbcode1_image (_BBCODE_LISTORDER, '', 'olist', 'ol.png', $form);
			$this->build_bbcode_image (_BBCODE_LISTITEM, 'listitem', 'list.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_DEFLIST, '', 'dl', 'dl.png', $form);
			$this->build_bbcode1_image (_BBCODE_DEFTERM, '', 'dt', 'dt.png', $form);
			$this->build_bbcode1_image (_BBCODE_DEFDEFINITION, '', 'dd', 'dd.png', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_TABLE, '', 'table', 'table.gif', $form);
			$this->build_bbcode1_image (_BBCODE_TABLEROW, '', 'tr', 'tr.gif', $form);
			$this->build_bbcode1_image (_BBCODE_TABLECOL, '', 'td', 'td.gif', $form);
			if ( ($smilieid != '') || ($userimagesid != '') ) {
				$this->_add_bbcode_ruler ($form);
				if ($smilieid != '') {
					$this->_build_bbcode_image ($url = '', 'smilie.gif', _BBCODE_SMILIESSHOW);
					$url = '<a href="javascript:blocking(\'' . $smilieid . '\')">' . $url . '</a>';
					$form->AddText ($url);
				}
				if ($userimagesid != '') {
					$this->_build_bbcode_image ($url = '', 'imgpool.gif', _BBCODE_IMGSHOW);
					$url = '<a href="javascript:blocking(\'' . $userimagesid . '\')">' . $url . '</a>';
					$form->AddText ($url);
				}
			}
			$form->SetEndCol ();
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$options = array ();
			$options[''] = _BBCODE_FONTSIZE;
			for ($i = 8; $i<25; $i++) {
				$options[$i] = $i;
			}
			$elem1 = explode ('.', $elem);
			$elem1 = $elem1[0];
			$form->AddSelect ('size', $options, _BBCODE_FONTSIZE, 'setbbcodefontsize(document.' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex);
			$options = array ();
			$options[''] = _BBCODE_FONT;
			$options['Arial'] = _BBCODE_FONT_ARIAL;
			$options['Courier'] = _BBCODE_FONT_COURIER;
			$options['Geneva'] = _BBCODE_FONT_GENEVA;
			$options['Helvetica'] = _BBCODE_FONT_HELVETICA;
			$options['Impact'] = _BBCODE_FONT_IMPACT;
			$options['Monospace'] = _BBCODE_FONT_MONOSPACE;
			$options['Optima'] = _BBCODE_FONT_OPTIMA;
			$options['Times'] = _BBCODE_FONT_TIMES;
			$options['Times New Roman'] = _BBCODE_FONT_TIMES_NEW_ROMAN;
			$options['Verdana'] = _BBCODE_FONT_VERDANA;
			$form->AddSelect ('font', $options, _BBCODE_FONT, 'setbbcodefont(' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex, '', 'font-family');
			$options = array ();
			$options[''] = _BBCODE_SELECT_COLOR;
			$options['Black'] = _BBCODE_BLACK;
			$options['Red'] = _BBCODE_RED;
			$options['Yellow'] = _BBCODE_YELLOW;
			$options['Pink'] = _BBCODE_PINK;
			$options['Green'] = _BBCODE_GREEN;
			$options['Orange'] = _BBCODE_ORANGE;
			$options['Purple'] = _BBCODE_PURPLE;
			$options['Blue'] = _BBCODE_BLUE;
			$options['Beige'] = _BBCODE_BEIGE;
			$options['Brown'] = _BBCODE_BROWN;
			$options['Teal'] = _BBCODE_TEAL;
			$options['Navy'] = _BBCODE_NAVY;
			$options['Maroon'] = _BBCODE_MAROON;
			$options['LimeGreen'] = _BBCODE_LIMEGREEN;
			$form->AddSelect ('color', $options, _BBCODE_SELECT_COLOR, 'setbbcodecolor(' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex, '', 'color');
			$options = array ();
			$options[''] = _BBCODE_SPECIAL_CHARS;
			$options['lt'] = _BBCODE_SPECIAL_LESS;
			$options['gt'] = _BBCODE_SPECIAL_GREATER;
			$options['bull'] = _BBCODE_SPECIAL_BULLET;
			$options['euro'] = _BBCODE_SPECIAL_EURO;
			$options['sect'] = _BBCODE_SPECIAL_PARAGRAPH;
			$options['copy'] = _BBCODE_SPECIAL_COPYRIGTH;
			$options['reg'] = _BBCODE_SPECIAL_REGISTERED;
			$options['trade'] = _BBCODE_SPECIAL_TRADEMARK;
			$options['deg'] = _BBCODE_SPECIAL_DEGREE;
			$options['permil'] = _BBCODE_SPECIAL_PERMILLE;
			$options['hellip'] = _BBCODE_SPECIA_HELL;
			$form->AddSelect ('chars', $options, _BBCODE_SPECIAL_CHARS, 'setbbcodechar(' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex);
			$form->SetEndCol ();
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->GetFormular ($txt = '');

			/*			$txt .= '<script type="text/javascript">'._OPN_HTML_NL;
			$txt .= '<!--'._OPN_HTML_NL;
			$txt .= 'addInfobox();'._OPN_HTML_NL;
			$txt .= '//-->'._OPN_HTML_NL.'</script>'._OPN_HTML_NL; */
			return $txt;

		}

		function build_bbcode_setspan_image ($text, $what, $what1, $image, &$form) {

			$wichFunction = 'setbbcodespan(' . $this->_elem . ',\'%s\',\'%s\');';
			$url = sprintf ($wichFunction, $what, $what1);
			$this->_build_bbcode_image ($url, $image, $text);
			$form->AddText ($url);

		}

		function build_bbcode_image ($text, $what, $image, &$form) {

			$url = 'DoPromptBBcode(' . $this->_elem . ',\'' . $what . '\');';
			$this->_build_bbcode_image ($url, $image, $text);
			$form->AddText ($url);

		}

		function build_bbcode1_image ($text, $text1, $bbcode, $image, &$form) {

			$t = $text1;
			$url = 'setbbcode(' . $this->_elem . ',\'' . $bbcode . '\');';
			$this->_build_bbcode_image ($url, $image, $text);
			$form->AddText ($url);

		}

		function _build_bbcode_image (&$url, $image, $text) {

			global $opnConfig;

			$url = '<img onclick="' . $url . '"onmouseover="bbc_highlight(this, true);" onmouseout="if (window.bbc_highlight) bbc_highlight(this, false);"';
			$url .= ' src="' . $opnConfig['opn_default_images'] . 'bbcode/' . $image . '"';
			$url .= ' width="23" height="22" alt="' . $text . '" title="' . $text . '"';
			$url .= ' style="background-image: url(' . $opnConfig['opn_default_images'] . 'bbcode/bbc_bg.gif);" class="editorimage" />';

		}

		function _add_bbcode_ruler (&$form) {

			global $opnConfig;

			$form->AddText ('<img src="' . $opnConfig['opn_default_images'] . 'bbcode/divider.gif" alt="|" style="margin: 0 3px 0 3px;" />');

		}

	}
}

?>